<h1 align="center">
  <br>
  <img src="http://usbac.com.ve/wp-content/uploads/2019/05/wolff-logo-2.0.png" alt="Wolff logo" width="200">
  <br>
  Wolff
  <br>
</h1>

<h4 align="center">Ridiculously small PHP framework.</h4>

<p align="center">
<img src="https://img.shields.io/badge/stability-stable-green.svg"> <img src="https://img.shields.io/badge/version-2.4-blue.svg"> <img src="https://img.shields.io/badge/license-MIT-orange.svg">
</p>

Wolff is a ridiculously small and lightweight PHP framework.

It is intended for those who want to build lightweight websites without starting from scratch or dealing with large frameworks.

Wolff is small, fast, scalable and easy. The perfect solution for building small and medium-sized web applications.


> **Note:** The core code of the framework is available at [Wolff-framework](https://github.com/usbac/wolff-framework).


## Features

* **Clean**: The routes system allows you to have clean and friendly URLs, and the template system makes the php code cleaner while separating the logic from the view.

* **Dynamic**: You can work however you want without strictly following the Wolff design or patterns like the MVC.

* **Extensible**: Take advantage of the custom middlewares, functions and templates you can make in Wolff to expand your page.

* **Fast**: Due to its small size and simplicity, you don’t have to worry about loading times or resource usage.

* **Simple**: It’s not only small, but simple as well; with a clean documentation and an easy way to use.


## What's included

* **Database abstraction layer**: Which simplifies the process of running queries and includes useful functions.

* **DI Container**: For managing class dependencies and performing DI.

* **Language system**: For managing multiple languages easily and quickly.

* **Middleware system**: Which gives you more control over your requests/responses.

* **Routing system**: Have clean URLs, make redirections and block certain pages recursively.

* **Standard library**: With numerous incredible functions related to strings, numbers, debugging and arrays.

* **Template engine**: Which you can use to write cleaner and safer code in your views while avoid things like the php tags.

* **Multiple utilities**: Including a paginate, validate and uploader utility.

And more...


## Requirements

* PHP version 7.0 or higher

* Composer


## Install

You must have [composer](https://getcomposer.org/) in your system for installing Wolff, once you have it.

Open your favorite terminal, move to the folder where you want Wolff to be installed and run the following command:

```
composer create-project usbac/wolff
```

This will download the whole project with everything ready to run (including an example page)!

You can see more information about the installation process in the [Wiki - install](https://github.com/Usbac/Wolff/wiki/Installation) page.


## Documentation

First time using it? Read the [Wiki](https://github.com/Usbac/Wolff/wiki).

Want to create a route/page? Read the [Route page](https://github.com/Usbac/wolff/wiki/Routes).

Want to use the database or run queries? Read the [DB Page](https://github.com/Usbac/wolff/wiki/Database).

Want to use the container? Read the [Container Page](https://github.com/Usbac/wolff/wiki/Container).

## Contributing

Any contribution or support to this project in the form of a pull request or message will be highly appreciated.

Don't be shy :)


## License

Wolff is open-source software licensed under the [MIT license](https://github.com/Usbac/Wolff/blob/master/LICENSE).
